---
id: 6554e343caea913ffba7bec6
title: Step 75
challengeType: 20
dashedName: step-75
---

# --description--

Now, your function can be used both to encrypt and decrypt a message. Clean up your code with better variable names.

Change each occurrence of `encrypted_text` into `final_message`.

# --hints--

You should change each occurrence of `encrypted_text` into `final_message`.

```js
({
  test: () => {
    const l = code.match(/final_message/g).length
    assert.equal(l, 4)
  }
})
```

# --seed--

## --seed-contents--

```py

text = 'Hello Zaira'
custom_key = 'python'
--fcc-editable-region--
def vigenere(message, key, direction):
    key_index = 0
    alphabet = 'abcdefghijklmnopqrstuvwxyz'
    encrypted_text = ''

    for char in message.lower():
    
        # Append space to the message
        if char == ' ':
            encrypted_text += char
        else:        
            # Find the right key character to encode
            key_char = key[key_index % len(key)]
            key_index += 1

            # Define the offset and the encrypted letter
            offset = alphabet.index(key_char)
            index = alphabet.find(char)
            new_index = (index + offset*direction) % len(alphabet)
            encrypted_text += alphabet[new_index]
    
    return encrypted_text
--fcc-editable-region--    
encryption = vigenere(text, custom_key, 1)
print(encryption)
decryption = vigenere(encryption, custom_key, -1)
print(decryption)

```
